package com.hfkj.dao;

import com.hfkj.entity.SecMenu;
import com.hfkj.entity.SecMenuExample;
import com.hfkj.entity.SecMenuExample.Criteria;
import com.hfkj.entity.SecMenuExample.Criterion;
import org.apache.ibatis.jdbc.SQL;

import java.util.List;
import java.util.Map;

public class SecMenuSqlProvider {

    public String countByExample(SecMenuExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("sec_menu");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(SecMenuExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("sec_menu");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(SecMenu record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("sec_menu");
        
        if (record.getMenuName() != null) {
            sql.VALUES("menu_name", "#{menuName,jdbcType=VARCHAR}");
        }
        
        if (record.getMenuType() != null) {
            sql.VALUES("menu_type", "#{menuType,jdbcType=INTEGER}");
        }
        
        if (record.getMenuUrl() != null) {
            sql.VALUES("menu_url", "#{menuUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getMenuUrlImg() != null) {
            sql.VALUES("menu_url_img", "#{menuUrlImg,jdbcType=VARCHAR}");
        }
        
        if (record.getMenuPSid() != null) {
            sql.VALUES("menu_p_sid", "#{menuPSid,jdbcType=BIGINT}");
        }
        
        if (record.getMenuSort() != null) {
            sql.VALUES("menu_sort", "#{menuSort,jdbcType=INTEGER}");
        }
        
        if (record.getMenuDesc() != null) {
            sql.VALUES("menu_desc", "#{menuDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getMenuMobileUrl() != null) {
            sql.VALUES("menu_mobile_url", "#{menuMobileUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getShowOnMobile() != null) {
            sql.VALUES("show_on_mobile", "#{showOnMobile,jdbcType=INTEGER}");
        }
        
        return sql.toString();
    }

    public String selectByExample(SecMenuExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("menu_name");
        sql.SELECT("menu_type");
        sql.SELECT("menu_url");
        sql.SELECT("menu_url_img");
        sql.SELECT("menu_p_sid");
        sql.SELECT("menu_sort");
        sql.SELECT("menu_desc");
        sql.SELECT("menu_mobile_url");
        sql.SELECT("show_on_mobile");
        sql.FROM("sec_menu");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        SecMenu record = (SecMenu) parameter.get("record");
        SecMenuExample example = (SecMenuExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("sec_menu");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getMenuName() != null) {
            sql.SET("menu_name = #{record.menuName,jdbcType=VARCHAR}");
        }
        
        if (record.getMenuType() != null) {
            sql.SET("menu_type = #{record.menuType,jdbcType=INTEGER}");
        }
        
        if (record.getMenuUrl() != null) {
            sql.SET("menu_url = #{record.menuUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getMenuUrlImg() != null) {
            sql.SET("menu_url_img = #{record.menuUrlImg,jdbcType=VARCHAR}");
        }
        
        if (record.getMenuPSid() != null) {
            sql.SET("menu_p_sid = #{record.menuPSid,jdbcType=BIGINT}");
        }
        
        if (record.getMenuSort() != null) {
            sql.SET("menu_sort = #{record.menuSort,jdbcType=INTEGER}");
        }
        
        if (record.getMenuDesc() != null) {
            sql.SET("menu_desc = #{record.menuDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getMenuMobileUrl() != null) {
            sql.SET("menu_mobile_url = #{record.menuMobileUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getShowOnMobile() != null) {
            sql.SET("show_on_mobile = #{record.showOnMobile,jdbcType=INTEGER}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("sec_menu");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("menu_name = #{record.menuName,jdbcType=VARCHAR}");
        sql.SET("menu_type = #{record.menuType,jdbcType=INTEGER}");
        sql.SET("menu_url = #{record.menuUrl,jdbcType=VARCHAR}");
        sql.SET("menu_url_img = #{record.menuUrlImg,jdbcType=VARCHAR}");
        sql.SET("menu_p_sid = #{record.menuPSid,jdbcType=BIGINT}");
        sql.SET("menu_sort = #{record.menuSort,jdbcType=INTEGER}");
        sql.SET("menu_desc = #{record.menuDesc,jdbcType=VARCHAR}");
        sql.SET("menu_mobile_url = #{record.menuMobileUrl,jdbcType=VARCHAR}");
        sql.SET("show_on_mobile = #{record.showOnMobile,jdbcType=INTEGER}");
        
        SecMenuExample example = (SecMenuExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(SecMenu record) {
        SQL sql = new SQL();
        sql.UPDATE("sec_menu");
        
        if (record.getMenuName() != null) {
            sql.SET("menu_name = #{menuName,jdbcType=VARCHAR}");
        }
        
        if (record.getMenuType() != null) {
            sql.SET("menu_type = #{menuType,jdbcType=INTEGER}");
        }
        
        if (record.getMenuUrl() != null) {
            sql.SET("menu_url = #{menuUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getMenuUrlImg() != null) {
            sql.SET("menu_url_img = #{menuUrlImg,jdbcType=VARCHAR}");
        }
        
        if (record.getMenuPSid() != null) {
            sql.SET("menu_p_sid = #{menuPSid,jdbcType=BIGINT}");
        }
        
        if (record.getMenuSort() != null) {
            sql.SET("menu_sort = #{menuSort,jdbcType=INTEGER}");
        }
        
        if (record.getMenuDesc() != null) {
            sql.SET("menu_desc = #{menuDesc,jdbcType=VARCHAR}");
        }
        
        if (record.getMenuMobileUrl() != null) {
            sql.SET("menu_mobile_url = #{menuMobileUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getShowOnMobile() != null) {
            sql.SET("show_on_mobile = #{showOnMobile,jdbcType=INTEGER}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, SecMenuExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}
